//---------------------------------------------------------------------------
#include <math.h>
#include <vcl.h>
#include "Vector.h"
#include "Matrix.h"
#pragma hdrstop

#include "Glmain.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TFormMain *FormMain;
Vector V[6];
//---------------------------------------------------------------------------
__fastcall TFormMain::TFormMain(TComponent* Owner)
    : TForm(Owner)
{
}
//---------------------------------------------------------------------------
void __fastcall TFormMain::FormCreate(TObject *Sender)
{
    hdc = GetDC(Handle);
    SetPixelFormatDescriptor();
    hrc = wglCreateContext(hdc);
    if(hrc == NULL)
    	ShowMessage(":-)~ hrc == NULL");
    if(wglMakeCurrent(hdc, hrc) == false)
    	ShowMessage("Could not MakeCurrent");
    w = ClientWidth;
    h = ClientHeight;

    glEnable(GL_DEPTH_TEST);
    glEnable(GL_NORMALIZE);

    SetupTextures();
    SetupLighting();

   glClearColor(1.0f, 1.0f, 1.0f, 1.0f);




}
//---------------------------------------------------------------------------
void __fastcall TFormMain::SetPixelFormatDescriptor()
{
    PIXELFORMATDESCRIPTOR pfd = {     //      
    	sizeof(PIXELFORMATDESCRIPTOR),   //  
        1,         // 
        PFD_DRAW_TO_WINDOW |  //  
        PFD_SUPPORT_OPENGL |  //  OpenGl
        PFD_DOUBLEBUFFER,     //   
        PFD_TYPE_RGBA,        // RGBA 
        24,                   // 24   
        0,0,0,0,0,0,          //  
        0,                    //  
        0,                    //  
        0,                    //  
        0,0,0,0,              //  
        32,                   //32-  
        0,                    //  
        0,                    //  
        PFD_MAIN_PLANE,       //  
        0,                    //
        0,0,                  //  
    };
    PixelFormat = ChoosePixelFormat(hdc, &pfd);
    //      
    SetPixelFormat(hdc, PixelFormat, &pfd); //  

}
//---------------------------------------------------------------------------
void __fastcall TFormMain::FormResize(TObject *Sender)
{

    GLfloat nRange = 10.0;

    w = ClientWidth;
    h = ClientHeight;

   if(h == 0)  //    ,    
    	h = 1;
    glViewport(0, 0, w, h);  //      
    glMatrixMode(GL_PROJECTION);  //   
    glLoadIdentity(); //  
    if (w <= h)
        glOrtho (-nRange, nRange, -nRange*h/w, nRange*h/w, -nRange, nRange);
    else
	glOrtho (-nRange*w/h, nRange*w/h, -nRange, nRange, -nRange, nRange);
    glMatrixMode(GL_MODELVIEW);
    glLoadIdentity();  //  
            }
//---------------------------------------------------------------------------
void __fastcall TFormMain::RenderGLScene()
{
   glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
    //     
    DrawObjects(); //    
    glFlush();
    //        

}
//---------------------------------------------------------------------------
void DrawSpiral(double R,double r,double x,double y,double z)
{
 const int N=50;
 const int M=50;
 Vector V[N][M];
 Vector Norm[N][M];
 Vector NormV[N][M];
 glPushMatrix();
 glTranslatef(x,y,z);
 //glPolygonMode(GL_FRONT_AND_BACK,GL_LINE);
 // 
for(int i=0;i<N;i++)
 {
   for(int j=0;j<M;j++)
   {
     V[i][j].x=(R+r*cos(i*2*3.14/N))*sin(j*2*3.14/M);
     V[i][j].y=(R+r*cos(i*2*3.14/N))*cos(j*2*3.14/M);
     V[i][j].z=r*sin(i*2*3.14/N);
   }
 }
//   
 for(int i=0;i<N-1;i++)
 {
   for(int j=0;j<M-1;j++)
   {
     Norm[i][j]=(V[i+1][j]-V[i][j])^(V[i][j+1]-V[i][j]);
     Normalize( Norm[i][j]);
   }
 }
 for(int i=0;i<N-1;i++)
 {
   Norm[i][M-1]=(V[i+1][M-1]-V[i][M-1])^(V[i][0]-V[i][M-1]);
   Normalize(Norm[i][M-1]);
 }
 for(int j=0;j<M-1;j++)
 {
   Norm[N-1][j]=(V[0][j]-V[N-1][j])^(V[N-1][j+1]-V[N-1][j]);
   Normalize(Norm[N-1][j]);
 }
 Norm[N-1][M-1]=(V[0][M-1]-V[N-1][M-1])^(V[N-1][0]-V[N-1][M-1]);
 Normalize( Norm[N-1][M-1]);
 //   
for(int i=1;i<N;i++)
 {
   for(int j=1;j<M;j++)
   {
     NormV[i][j]=(Norm[i][j]+Norm[i-1][j]+Norm[i][j-1]+Norm[i-1][j-1])/4;
     Normalize(NormV[i][j]);
   }
 }
 for(int i=1;i<N;i++)
 {
   NormV[i][0]=(Norm[i][0]+Norm[i-1][0]+Norm[i][M-1]+Norm[i-1][M-1])/4;
   Normalize(NormV[i][0]);
 }
 for(int j=1;j<M;j++)
 {
   NormV[0][j]=(Norm[0][j]+Norm[N-1][j]+Norm[0][j-1]+Norm[N-1][j-1])/4;
   Normalize(NormV[0][j]);
 }
NormV[0][0]=(Norm[0][0]+Norm[N-1][0]+Norm[0][M-1]+Norm[N-1][M-1])/4;
Normalize(NormV[0][0]);
// 
/*glBegin(GL_LINES);
for(int i=0;i<N-1;i++)
 {
   for(int j=0;j<M-1;j++)
   {
     glVertex3d((V[i][j].x+V[i+1][j+1].x)/2,
                (V[i][j].y+V[i+1][j+1].y)/2,
                (V[i][j].z+V[i+1][j+1].z)/2);
     glVertex3d((V[i][j].x+V[i+1][j+1].x)/2+Norm[0][j].x,
                (V[i][j].y+V[i+1][j+1].y)/2+Norm[0][j].y,
                (V[i][j].z+V[i+1][j+1].z)/2+Norm[0][j].z);
   }
 }
glEnd();
glBegin(GL_LINES);
for(int i=0;i<N;i++)
 {
   for(int j=0;j<M;j++)
   {
     glVertex3d(V[i][j].x,V[i][j].y,V[i][j].z);
     glVertex3d(V[i][j].x+NormV[i][j].x,
                V[i][j].y+NormV[i][j].y,
                V[i][j].z+NormV[i][j].z);
   }
 }
glEnd(); */
 glBegin(GL_QUADS);
 for(int i=0;i<N-1;i++)
 {
   for(int j=0;j<M-1;j++)
   {
    // glNormal3d(Norm[i][j].x,Norm[i][j].y,Norm[i][j].z);
     glNormal3d(NormV[i][j].x,NormV[i][j].y,NormV[i][j].z);
     glTexCoord2d((double)i/N,(double)j/M);
     glVertex3d(V[i][j].x,V[i][j].y,V[i][j].z);
     glNormal3d(NormV[i+1][j].x,NormV[i+1][j].y,NormV[i+1][j].z);
     glTexCoord2d((double)(i+1)/N,(double)j/M);
     glVertex3d(V[i+1][j].x,V[i+1][j].y,V[i+1][j].z);
     glNormal3d(NormV[i+1][j+1].x,NormV[i+1][j+1].y,NormV[i+1][j+1].z);
     glTexCoord2d((double)(i+1)/N,(double)(j+1)/M);
     glVertex3d(V[i+1][j+1].x,V[i+1][j+1].y,V[i+1][j+1].z);
     glNormal3d(NormV[i][j+1].x,NormV[i][j+1].y,NormV[i][j+1].z);
     glTexCoord2d((double)i/N,(double)(j+1)/M);
     glVertex3d(V[i][j+1].x,V[i][j+1].y,V[i][j+1].z);
   }
 }
 glEnd();
 glBegin(GL_QUADS);
 for(int i=0;i<N-1;i++)
 {
     glNormal3d(Norm[i][M-1].x,Norm[i][M-1].y,Norm[i][M-1].z);
     glTexCoord2d((double)i/N,(double)1/M);
     glVertex3d(V[i][M-1].x,V[i][M-1].y,V[i][M-1].z);
     glTexCoord2d((double)(i+1)/N,(double)1/M);
     glVertex3d(V[i+1][M-1].x,V[i+1][M-1].y,V[i+1][M-1].z);
     glTexCoord2d((double)(i+1)/N,(double)2/M);
     glVertex3d(V[i+1][0].x,V[i+1][0].y,V[i+1][0].z);
     glTexCoord2d((double)i/N,(double)2/M);
     glVertex3d(V[i][0].x,V[i][0].y,V[i][0].z);
 }
  glEnd();
  glBegin(GL_QUADS);
  for(int j=0;j<M-1;j++)
   {
     glNormal3d(Norm[N-1][j].x,Norm[N-1][j].y,Norm[N-1][j].z);
     glTexCoord2d((double)(1/N),(double)(j/M));
     glVertex3d(V[M-1][j].x,V[M-1][j].y,V[M-1][j].z);
     glTexCoord2d((double)2/N,(double)j/M);
     glVertex3d(V[0][j].x,V[0][j].y,V[0][j].z);
     glTexCoord2d((double)2/N,(double)(j+1)/M);
     glVertex3d(V[0][j+1].x,V[0][j+1].y,V[0][j+1].z);
     glTexCoord2d((double)1/N,(double)(j+1)/M);
     glVertex3d(V[M-1][j+1].x,V[M-1][j+1].y,V[M-1][j+1].z);
   }
  glEnd();
 glPopMatrix();
}
//---------------------------------------------------------------------------
// 
void __fastcall TFormMain::DrawObjects()
{

 glBindTexture(GL_TEXTURE_2D,texture1);
 DrawSpiral(7,2,0,0,0);
}

//---------------------------------------------------------------------------
void __fastcall TFormMain::FormPaint(TObject *Sender)
{
    glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
    glFlush();
    DrawObjects();
}
//---------------------------------------------------------------------------
void __fastcall TFormMain::FormDestroy(TObject *Sender)
{
    wglMakeCurrent(NULL, NULL);
    wglDeleteContext(hrc);
}
//---------------------------------------------------------------------------
void __fastcall TFormMain::FormKeyDown(TObject *Sender, WORD &Key,
      TShiftState Shift)
{
    if(Key == VK_UP)
       { glRotatef(-10, 1.0, 0.0, 0.0);  }
    if(Key == VK_DOWN)
       { glRotatef(10, 1.0, 0.0, 0.0);}
    if(Key == VK_LEFT)
       { glRotatef(-10, 0.0, 1.0, 0.0); }
    if(Key == VK_RIGHT)
       { glRotatef(10, 0.0, 1.0, 0.0); }
}
//---------------------------------------------------------------------------
void __fastcall TFormMain::SetupTextures()
{
 bitmap = new Graphics::TBitmap;
    bitmap->LoadFromFile("/pic.bmp");
    GLubyte bits1[64][64][4];
    GLubyte bits2[64][64][4];
    GLubyte bits3[64][64][4];
    for(int i = 0; i < 64; i++)
    {
    	for(int j = 0; j < 64; j++)
        {
            bits1[i][j][0]= (GLbyte)GetRValue(bitmap->Canvas->Pixels[i][j]);
            bits1[i][j][1]= (GLbyte)GetGValue(bitmap->Canvas->Pixels[i][j]);
            bits1[i][j][2]= (GLbyte)GetBValue(bitmap->Canvas->Pixels[i][j]);
            bits1[i][j][3]= (GLbyte)255;
        }
    }
    glPixelStorei(GL_UNPACK_ALIGNMENT, 4);
    glGenTextures(1, &texture1);
    glBindTexture(GL_TEXTURE_2D, texture1);
    glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_S, GL_CLAMP);
    glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_T, GL_CLAMP);
    glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_NEAREST);
    glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_NEAREST);
    glTexImage2D(GL_TEXTURE_2D, 0, GL_RGBA, 64, 64, 0, GL_RGBA, GL_UNSIGNED_BYTE, bits1);
    glEnable(GL_TEXTURE_2D);
    glTexEnvf(GL_TEXTURE_ENV, GL_TEXTURE_ENV_MODE, GL_MODULATE);
    }
//---------------------------------------------------------------------------

void __fastcall TFormMain::SetupLighting()
{
    GLfloat MaterialAmbient[] = {1.0, 1.0, 1.0, 1.0};
    GLfloat MaterialDiffuse[] = {1.0, 1.0, 1.0, 1.0};
    GLfloat MaterialSpecular[] = {1.0, 1.0, 1.0, 1.0};
    GLfloat MaterialShininess[] = {100.0};
    GLfloat AmbientLightPosition[] = {0.5, 1.0, 1.0, 0.0};
    GLfloat LightAmbient[] = {0.5, 0.5, 0.5, 1.0};

    glMaterialfv(GL_FRONT, GL_AMBIENT, MaterialAmbient);
    glMaterialfv(GL_FRONT, GL_DIFFUSE, MaterialDiffuse);
    glMaterialfv(GL_FRONT, GL_SPECULAR, MaterialSpecular);
    glMaterialfv(GL_FRONT, GL_SHININESS, MaterialShininess);
    glLightfv(GL_LIGHT0, GL_POSITION, AmbientLightPosition);
    glLightModelfv(GL_LIGHT_MODEL_AMBIENT, LightAmbient);

    glEnable(GL_LIGHTING);
    glEnable(GL_LIGHT0);
    glEnable(GL_COLOR_MATERIAL);
    glColorMaterial(GL_FRONT, GL_AMBIENT_AND_DIFFUSE);
    glShadeModel(GL_SMOOTH);
}
//---------------------------------------------------------------------------
void __fastcall TFormMain::Timer1Timer(TObject *Sender)
{
   RenderGLScene();   // 
    SwapBuffers(hdc);  //  

}
//---------------------------------------------------------------------------

