//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop
#include <Math.h>
#include "glcil.h"


//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TFormMain *FormMain;
int r=16;
int R=5;
int i,j,k;

//---------------------------------------------------------------------------
__fastcall TFormMain::TFormMain(TComponent* Owner)
    : TForm(Owner)
{
    Application->OnIdle = IdleLoop;
    size = 100.0f;
}
//---------------------------------------------------------------------------
void __fastcall TFormMain::IdleLoop(TObject*, bool& done)
{
    done = false;
    RenderGLScene();
    SwapBuffers(hdc);
}
//---------------------------------------------------------------------------
void __fastcall TFormMain::FormCreate(TObject *Sender)
{
    hdc = GetDC(Handle);
    SetPixelFormatDescriptor();
    hrc = wglCreateContext(hdc);
    if(hrc == NULL)
    	ShowMessage(":-)~ hrc == NULL");
    if(wglMakeCurrent(hdc, hrc) == false)
    	ShowMessage("Could not MakeCurrent");
    w = ClientWidth;
    h = ClientHeight;

   glEnable(GL_DEPTH_TEST);
    //glEnable(GL_CULL_FACE);
    glEnable(GL_NORMALIZE);
    glClearColor(0.5f,0.5f,0.5f, 1.0f);
  SetupLighting();
  SetupTextures();
    CreateInpriseCorporateLogo();

}
//---------------------------------------------------------------------------
void __fastcall TFormMain::SetPixelFormatDescriptor()
{
    PIXELFORMATDESCRIPTOR pfd = {
    	sizeof(PIXELFORMATDESCRIPTOR),
        1,
        PFD_DRAW_TO_WINDOW | PFD_SUPPORT_OPENGL | PFD_DOUBLEBUFFER,
        PFD_TYPE_RGBA,
        24,
        0,0,0,0,0,0,
        0,0,
        0,0,0,0,0,
        32,
        0,
        0,
        PFD_MAIN_PLANE,
        0,
        0,0,
    };
    PixelFormat = ChoosePixelFormat(hdc, &pfd);
    SetPixelFormat(hdc, PixelFormat, &pfd);
}
//---------------------------------------------------------------------------
void __fastcall TFormMain::FormResize(TObject *Sender)
{

    GLfloat nRange = 50.0;

    w = ClientWidth;
    h = ClientHeight;

    if(h == 0)
    	h = 1;

    glViewport(0, 0, w, h);


    glMatrixMode(GL_PROJECTION);
    glLoadIdentity();

    if (w <= h)
        glOrtho (-nRange, nRange, -nRange*h/w, nRange*h/w, -nRange, nRange);
    else
	glOrtho (-nRange*w/h, nRange*w/h, -nRange, nRange, -nRange, nRange);

    //For perspective correction
    //GLfloat aspect = (GLfloat)w/(GLfloat)h;
    //gluPerspective(30.0f, aspect, 1.0, 50.0);


    glMatrixMode(GL_MODELVIEW);
    glLoadIdentity();
}
//---------------------------------------------------------------------------
void __fastcall TFormMain::RenderGLScene()
{
    glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
    DrawObjects();
    glFlush();
}
//---------------------------------------------------------------------------
void __fastcall TFormMain::DrawObjects()
{
    DrawCilindr();
}
void __fastcall TFormMain::DrawCilindr()
{
 glPolygonMode(GL_FRONT_AND_BACK,GL_FILL);

  glBindTexture(GL_TEXTURE_2D, texture1);
   int N=10, M=10;

//------------------

  glBegin(GL_QUADS);   N=100;M=100;
    for(i=0;i<N;i++){
         for(int j=0;j<M;j++){
glTexCoord2d((double)i/N,(double)j/M);
  glNormal3f(r*cos(2*i*M_PI/N)*sin(j*M_PI/M),r*sin(2*i*M_PI/N)*sin(j*M_PI/M),r*cos(j*M_PI/M));
     glVertex3f(r*cos(2*i*M_PI/N)*sin(j*M_PI/M),r*sin(2*i*M_PI/N)*sin(j*M_PI/M),r*cos(j*M_PI/M));

glTexCoord2d((double)(i+1)/N,(double)j/M);
  glNormal3f(r*cos(2*(i+1)*M_PI/N)*sin((j)*M_PI/M),r*sin(2*(i+1)*M_PI/N)*sin((j)*M_PI/M),r*cos((j)*M_PI/M));
     glVertex3f(r*cos(2*(i+1)*M_PI/N)*sin((j)*M_PI/M),r*sin(2*(i+1)*M_PI/N)*sin((j)*M_PI/M),r*cos((j)*M_PI/M));

glTexCoord2d((double)(i+1)/N,(double)(j+1)/M);
  glNormal3f(r*cos(2*(i+1)*M_PI/N)*sin((j+1)*M_PI/M),r*sin(2*(i+1)*M_PI/N)*sin((j+1)*M_PI/M),r*cos((j+1)*M_PI/M));
     glVertex3f(r*cos(2*(i+1)*M_PI/N)*sin((j+1)*M_PI/M),r*sin(2*(i+1)*M_PI/N)*sin((j+1)*M_PI/M),r*cos((j+1)*M_PI/M));

glTexCoord2d((double)i/N,(double)(j+1)/M);
  glNormal3f(r*cos(2*(i)*M_PI/N)*sin((j+1)*M_PI/M),r*sin(2*(i)*M_PI/N)*sin((j+1)*M_PI/M),r*cos((j+1)*M_PI/M));
     glVertex3f(r*cos(2*(i)*M_PI/N)*sin((j+1)*M_PI/M),r*sin(2*(i)*M_PI/N)*sin((j+1)*M_PI/M),r*cos((j+1)*M_PI/M));
       }//for
        }//for

  glEnd();

//-----------------

  glBegin(GL_QUADS); N=100;
    for(i=0;i<N;i++){
glTexCoord2d((double)i/N,(double)i/N);
   glNormal3f((R+2.5)*cos(2*i*M_PI/N),(R+2.5)*sin(2*i*M_PI/N),0);
     glVertex3f((R+2.5)*cos(2*i*M_PI/N),(R+2.5)*sin(2*i*M_PI/N),0);

glTexCoord2d((double)(i+1)/N,(double)i/N);
   glNormal3f((R+2.5)*cos(2*(i+1)*M_PI/N),(R+2.5)*sin(2*(i+1)*M_PI/N),0);
     glVertex3f((R+2.5)*cos(2*(i+1)*M_PI/N),(R+2.5)*sin(2*(i+1)*M_PI/N),0);

glTexCoord2d((double)(i+1)/N,(double)(i+1)/N);
   glNormal3f(R*cos(2*(i+1)*M_PI/N),R*sin(2*(i+1)*M_PI/N),40);
     glVertex3f(R*cos(2*(i+1)*M_PI/N),R*sin(2*(i+1)*M_PI/N),40);

glTexCoord2d((double)i/N,(double)(i+1)/N);
   glNormal3f(R*cos(2*i*M_PI/N),R*sin(2*i*M_PI/N),40);
     glVertex3f(R*cos(2*i*M_PI/N),R*sin(2*i*M_PI/N),40);
        } //for
   glEnd();

//--------------------

  glBegin(GL_POLYGON);
        for(i=0;i<N;i++){
glTexCoord2d((double)i/N,(double)(i+1)/N);
   glNormal3f(R*cos(2*i*M_PI/N),R*sin(2*i*M_PI/N),40);
    glVertex3f(R*cos(2*i*M_PI/N),R*sin(2*i*M_PI/N),40);
      }//for
  glEnd();

//-----------------

      for(k=15;k<315;k=k+45){
        for(j=15;j<315;j=j+45){
glPushMatrix();
             glRotated(30+j, 1,0,0);
             glRotated(30+k, 0,1,0);
             //glColor3d(0,1,0);
  glBegin(GL_TRIANGLES);
     for(i=0;i<N;i++){   float rr=2.5;
       x=0;y=0;z=-15;
     glTexCoord2d((double)i/N,(double)(i+1)/N);
       glNormal3f(x,y,z-5);
        glVertex3f(x,y,z-5);

     glTexCoord2d((double)(i+1)/N,(double)(i+1)/N);
       glNormal3f((x+rr*cos(2*(i+1)*M_PI/N)), (y+rr*sin(2*(i+1)*M_PI/N)),z);
        glVertex3f((x+rr*cos(2*(i+1)*M_PI/N)), (y+rr*sin(2*(i+1)*M_PI/N)),z);

     glTexCoord2d((double)i/N,(double)i/N);
       glNormal3f((x+rr*cos(2*i*M_PI/N)),( y+rr*sin(2*i*M_PI/N)),z);
        glVertex3f((x+rr*cos(2*i*M_PI/N)),( y+rr*sin(2*i*M_PI/N)),z);
       }//for
  glEnd();
glPopMatrix();
     }//for
      }//for
}
 
//---------------------------------------------------------------------------
void __fastcall TFormMain::FormPaint(TObject *Sender)
{
    glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
    glFlush();
    DrawObjects();
}
//---------------------------------------------------------------------------
void __fastcall TFormMain::FormDestroy(TObject *Sender)
{
    gluDeleteQuadric(GoldCube);
    gluDeleteQuadric(GoldCubeTop);
    gluDeleteQuadric(GoldCubeBottom);
    gluDeleteQuadric(RedPyramid);
    gluDeleteQuadric(RedPyramidBottom);
    gluDeleteQuadric(BlueSphere);
    gluDeleteQuadric(Ring);
    delete bitmap;
    wglMakeCurrent(NULL, NULL);
    wglDeleteContext(hrc);
}
//---------------------------------------------------------------------------
void __fastcall TFormMain::CreateInpriseCorporateLogo()
{
   startoflist = glGenLists(2);
     DrawCilindr();
}

//---------------------------------------------------------------------------
void __fastcall TFormMain::FormKeyDown(TObject *Sender, WORD &Key,
      TShiftState Shift)
{
    if(Key == VK_UP)
        glRotatef(-5, 1.0, 0.0, 0.0);
    if(Key == VK_DOWN)
        glRotatef(5, 1.0, 0.0, 0.0);
    if(Key == VK_LEFT)
        glRotatef(-5, 0.0, 1.0, 0.0);
    if(Key == VK_RIGHT)
        glRotatef(5, 0.0, 1.0, 0.0);
}
//---------------------------------------------------------------------------
void __fastcall TFormMain::SetupLighting()
{
    GLfloat MaterialAmbient[] = {0, 0, 1.0,1.0};
    GLfloat MaterialDiffuse[] = {0, 0, 1.0, 1.0};
    GLfloat MaterialSpecular[] = {0, 0, 1.0, 1.0};
    GLfloat MaterialShininess[] = {50.0};
    GLfloat AmbientLightPosition[] = {0.5, 1.0, 1.0, 0.0};
    GLfloat LightAmbient[] = {0.5, 0.5, 0.5, 1.0};

    glMaterialfv(GL_FRONT, GL_AMBIENT, MaterialAmbient);
    glMaterialfv(GL_FRONT, GL_DIFFUSE, MaterialDiffuse);
    glMaterialfv(GL_FRONT, GL_SPECULAR, MaterialSpecular);
    glMaterialfv(GL_FRONT, GL_SHININESS, MaterialShininess);
    glLightfv(GL_LIGHT0, GL_POSITION, AmbientLightPosition);
    glLightModelfv(GL_LIGHT_MODEL_AMBIENT, LightAmbient);

    glEnable(GL_LIGHTING);
    glEnable(GL_LIGHT0);
    glEnable(GL_COLOR_MATERIAL);
//    glColorMaterial(GL_FRONT, GL_AMBIENT_AND_DIFFUSE);
    glShadeModel(GL_SMOOTH);
}
//---------------------------------------------------------------------------
void __fastcall TFormMain::SetupTextures()
{
    bitmap = new Graphics::TBitmap;
    bitmap->LoadFromFile("red.bmp");
    GLubyte bits[64][64][4];
    for(int i = 0; i < 64; i++)
    {
    	for(int j = 0; j < 64; j++)
        {
            bits[i][j][0]= (GLbyte)GetRValue(bitmap->Canvas->Pixels[i][j]);
            bits[i][j][1]= (GLbyte)GetGValue(bitmap->Canvas->Pixels[i][j]);
            bits[i][j][2]= (GLbyte)GetBValue(bitmap->Canvas->Pixels[i][j]);
            bits[i][j][3]= (GLbyte)255;
        }
    }
    glPixelStorei(GL_UNPACK_ALIGNMENT, 4);
    glGenTextures(1, &texture1);
    glBindTexture(GL_TEXTURE_2D, texture1);
    glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_S, GL_CLAMP);
    glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_T, GL_CLAMP);
    glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_NEAREST);
    glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_NEAREST);
    glTexImage2D(GL_TEXTURE_2D, 0, GL_RGBA, 64, 64, 0, GL_RGBA, GL_UNSIGNED_BYTE, bits);

   /* bitmap->LoadFromFile("gold.bmp");
    for(int i = 0; i < 64; i++)
    {
    	for(int j = 0; j < 64; j++)
        {
            bits[i][j][0]= (GLbyte)GetRValue(bitmap->Canvas->Pixels[i][j]);
            bits[i][j][1]= (GLbyte)GetGValue(bitmap->Canvas->Pixels[i][j]);
            bits[i][j][2]= (GLbyte)GetBValue(bitmap->Canvas->Pixels[i][j]);
            bits[i][j][3]= (GLbyte)255;
        }
    }
    glPixelStorei(GL_UNPACK_ALIGNMENT, 4);
    glGenTextures(1, &texture2);
    glBindTexture(GL_TEXTURE_2D, texture2);
    glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_S, GL_CLAMP);
    glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_T, GL_CLAMP);
    glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_NEAREST);
    glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_NEAREST);
    glTexImage2D(GL_TEXTURE_2D, 0, GL_RGBA, 64, 64, 0, GL_RGBA, GL_UNSIGNED_BYTE, bits);

    bitmap->LoadFromFile("blue.bmp");
    for(int i = 0; i < 64; i++)
    {
    	for(int j = 0; j < 64; j++)
        {
            bits[i][j][0]= (GLbyte)GetRValue(bitmap->Canvas->Pixels[i][j]);
            bits[i][j][1]= (GLbyte)GetGValue(bitmap->Canvas->Pixels[i][j]);
            bits[i][j][2]= (GLbyte)GetBValue(bitmap->Canvas->Pixels[i][j]);
            bits[i][j][3]= (GLbyte)255;
        }
    }
    glPixelStorei(GL_UNPACK_ALIGNMENT, 4);
    glGenTextures(1, &texture3);*/
    //glBindTexture(GL_TEXTURE_2D, texture3);
    glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_S, GL_CLAMP);
    glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_T, GL_CLAMP);
    glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_NEAREST);
    glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_NEAREST);
    glTexImage2D(GL_TEXTURE_2D, 0, GL_RGBA, 64, 64, 0, GL_RGBA, GL_UNSIGNED_BYTE, bits);

    glEnable(GL_TEXTURE_2D);
    glTexEnvf(GL_TEXTURE_ENV, GL_TEXTURE_ENV_MODE, GL_MODULATE);
}


