//---------------------------------------------------------------------------
#include <math.h>
#include <vcl.h>
#include "Vector.h"
#include "Matrix.h"
#pragma hdrstop

#include "Glmain.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TFormMain *FormMain;
const N=50;
float R=0.18;

//---------------------------------------------------------------------------
__fastcall TFormMain::TFormMain(TComponent* Owner)
    : TForm(Owner)
{
}
//---------------------------------------------------------------------------
void __fastcall TFormMain::FormCreate(TObject *Sender)
{
    hdc = GetDC(Handle);
    SetPixelFormatDescriptor();
    hrc = wglCreateContext(hdc);
    if(hrc == NULL)
    	ShowMessage(":-)~ hrc == NULL");
    if(wglMakeCurrent(hdc, hrc) == false)
    	ShowMessage("Could not MakeCurrent");
    w = ClientWidth;
    h = ClientHeight;

    glEnable(GL_DEPTH_TEST);
    glEnable(GL_NORMALIZE);

    SetupTextures();
    SetupLighting();

   glClearColor(0.7f, 0.8f, 0.9f, 1.0f);

}
//---------------------------------------------------------------------------
void __fastcall TFormMain::SetPixelFormatDescriptor()
{
    PIXELFORMATDESCRIPTOR pfd = {     //      
    	sizeof(PIXELFORMATDESCRIPTOR),   //  
        1,         // 
        PFD_DRAW_TO_WINDOW |  //  
        PFD_SUPPORT_OPENGL |  //  OpenGl
        PFD_DOUBLEBUFFER,     //   
        PFD_TYPE_RGBA,        // RGBA 
        24,                   // 24   
        0,0,0,0,0,0,          //  
        0,                    //  
        0,                    //  
        0,                    //  
        0,0,0,0,              //  
        32,                   //32-  
        0,                    //  
        0,                    //  
        PFD_MAIN_PLANE,       //  
        0,                    //
        0,0,                  //  
    };
    PixelFormat = ChoosePixelFormat(hdc, &pfd);
    //      
    SetPixelFormat(hdc, PixelFormat, &pfd); //  

}
//---------------------------------------------------------------------------
void __fastcall TFormMain::FormResize(TObject *Sender)
{

    GLfloat nRange = 15;

    w = ClientWidth;
    h = ClientHeight;

   if(h == 0)  //    ,    
    	h = 1;
    glViewport(0, 0, w, h);  //      
    glMatrixMode(GL_PROJECTION);  //   
    glLoadIdentity(); //  
    if (w <= h)
        glOrtho (-nRange, nRange, -nRange*h/w, nRange*h/w, -nRange, nRange);
    else
	glOrtho (-nRange*w/h, nRange*w/h, -nRange, nRange, -nRange, nRange);
    glMatrixMode(GL_MODELVIEW);
    glLoadIdentity();  //  
            }
//---------------------------------------------------------------------------
void __fastcall TFormMain::RenderGLScene()
{
   glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
    //     
    DrawObjects(); //    
    glFlush();
    //        

}

//----------------------------   --------------------------------
void Draw_skin()
{

// ----------------------   :) -----------------------------
glBegin (GL_QUADS);

        //  
        glNormal3f(2, 0, 0);
        glTexCoord2f(0.0f, 0.0f); glVertex3f(2, 0, 0);

        glNormal3f(2, 9, 0);
        glTexCoord2f(1.0f, 0.0f); glVertex3f(2, 9, 0);

        glNormal3f(2, 9, 7);
        glTexCoord2f(1.0f, 1.0f); glVertex3f(2, 9, 7);

        glNormal3f(2, 0, 7);
        glTexCoord2f(0.0f, 1.0f); glVertex3f(2, 0, 7);

        //  
        glNormal3f(0, 0, 0);
        glTexCoord2f(0.0f, 0.0f); glVertex3f(0, 0, 0);

        glNormal3f(0, 9, 0);
        glTexCoord2f(1.0f, 0.0f); glVertex3f(0, 9, 0);

        glNormal3f(0, 9, 7);
        glTexCoord2f(1.0f, 1.0f); glVertex3f(0, 9, 7);

        glNormal3f(0, 0, 7);
        glTexCoord2f(0.0f, 1.0f); glVertex3f(0, 0, 7);

        //  
        glNormal3f(0, 0, 0);
        glTexCoord2f(0.0f, 0.0f); glVertex3f(0, 0, 0);

        glNormal3f(2, 0, 0);
        glTexCoord2f(1.0f, 0.0f); glVertex3f(2, 0, 0);

        glNormal3f(2, 0, 7);
        glTexCoord2f(1.0f, 1.0f); glVertex3f(2, 0, 7);

        glNormal3f(0, 0, 7);
        glTexCoord2f(0.0f, 1.0f); glVertex3f(0, 0, 7);
        //  

        glNormal3f(2, 9, 0);
        glTexCoord2f(0.0f, 0.0f); glVertex3f(2, 9, 0);

        glNormal3f(0, 9, 0);
        glTexCoord2f(1.0f, 0.0f); glVertex3f(0, 9, 0);

        glNormal3f(0, 9, 7);
        glTexCoord2f(1.0f, 1.0f); glVertex3f(0, 9, 7);

        glNormal3f(2, 9, 7);
        glTexCoord2f(0.0f, 1.0f); glVertex3f(2, 9, 7);
        //  

        glNormal3f(2, 0, 0);
        glTexCoord2f(0.0f, 0.0f); glVertex3f(2, 0, 0);

        glNormal3f(2, 9, 0);
        glTexCoord2f(1.0f, 0.0f); glVertex3f(2, 9, 0);

        glNormal3f(0, 9, 0);
        glTexCoord2f(1.0f, 1.0f); glVertex3f(0, 9, 0);

        glNormal3f(0, 0, 0);
        glTexCoord2f(0.0f, 1.0f); glVertex3f(0, 0, 0);

        //  
        glNormal3f(2.3, 0, 7);
        glTexCoord2f(0.0f, 0.0f); glVertex3f(2.3, 0, 7);

        glNormal3f(2.3, 9, 7);
        glTexCoord2f(1.0f, 0.0f); glVertex3f(2.3, 9, 7);

        glNormal3f(0, 9, 7);
        glTexCoord2f(1.0f, 1.0f); glVertex3f(0, 9, 7);

        glNormal3f(0, 0, 7);
        glTexCoord2f(0.0f, 1.0f); glVertex3f(0, 0, 7);
glEnd();

// -------------------------    ----------------------------
glBegin (GL_POLYGON);

        glNormal3f(2.3, 0, 7);
        glTexCoord2f(0.0f, 0.0f); glVertex3f(2.3, 0, 7);

        glNormal3f(2.3, 0, 4.2);
        glTexCoord2f(1.0f, 0.0f); glVertex3f(2.3, 0, 4.2);

        glNormal3f(2.3, 0.7, 3.5);
        glTexCoord2f(1.0f, 0.1f); glVertex3f(2.3, 0.7, 3.5);

        glNormal3f(2.3, 8.3, 3.5);
        glTexCoord2f(1.0f, 1.0f); glVertex3f(2.3, 8.3, 3.5);

        glNormal3f(2.3, 9, 4.2);
        glTexCoord2f(1.0f, 1.0f); glVertex3f(2.3, 9, 4.2);

        glNormal3f(2.3, 9, 7);
        glTexCoord2f(0.0f, 1.0f); glVertex3f(2.3, 9, 7);
glEnd();

//   
glBegin (GL_QUADS);
        // 
        glTexCoord2f(0.0f, 0.0f); glVertex3f(2.05, 0, 4.2);
        glTexCoord2f(1.0f, 0.0f); glVertex3f(2.3, 0, 4.2);
        glTexCoord2f(1.0f, 1.0f); glVertex3f(2.3, 0, 7);
        glTexCoord2f(0.0f, 1.0f); glVertex3f(2.05, 0, 7);
        // 
        glTexCoord2f(0.0f, 0.0f); glVertex3f(2.05, 9, 4.2);
        glTexCoord2f(1.0f, 0.0f); glVertex3f(2.3, 9, 4.2);
        glTexCoord2f(1.0f, 1.0f); glVertex3f(2.3, 9, 7);
        glTexCoord2f(0.0f, 1.0f); glVertex3f(2.05, 9, 7);
        // 
        glTexCoord2f(0.0f, 0.0f); glVertex3f(2.3, 0.7, 3.5);
        glTexCoord2f(1.0f, 0.0f); glVertex3f(2.3, 8.3, 3.5);
        glTexCoord2f(1.0f, 1.0f); glVertex3f(2.05, 8.3, 3.5);
        glTexCoord2f(0.0f, 1.0f); glVertex3f(2.05, 0.7, 3.5);
        // 
        glTexCoord2f(0.0f, 0.0f); glVertex3f(2.3, 0, 4.2);
        glTexCoord2f(1.0f, 0.0f); glVertex3f(2.3, 0.7, 3.5);
        glTexCoord2f(1.0f, 1.0f); glVertex3f(2.05, 0.7, 3.5);
        glTexCoord2f(0.0f, 1.0f); glVertex3f(2.05, 0, 4.2);
        // 
        glTexCoord2f(0.0f, 0.0f); glVertex3f(2.3, 8.3, 3.5);
        glTexCoord2f(1.0f, 0.0f); glVertex3f(2.3, 9, 4.2);
        glTexCoord2f(1.0f, 1.0f); glVertex3f(2.05, 9, 4.2);
        glTexCoord2f(0.0f, 1.0f); glVertex3f(2.05, 8.3, 3.5);
glEnd();

// ---------------------------  ----------------------------------------

//   
glBegin(GL_QUADS);
   for (int i=0; i<N; i++)
       {

       glVertex3f(R*sin(2*M_PI/N*i)+1.15, 3, R*cos(2*M_PI/N*i)+7.2);

       glVertex3f(R*sin(2*M_PI/N*i)+1.15, 3.3, R*cos(2*M_PI/N*i)+7.2+0.4);

       glVertex3f(R*sin(2*M_PI/N*(i+1))+1.15, 3.3, R*cos(2*M_PI/N*(i+1))+7.2+0.4);

       glVertex3f(R*sin(2*M_PI/N*(i+1))+1.15, 3, R*cos(2*M_PI/N*(i+1))+7.2);
       }
glEnd();

//   
glBegin(GL_QUADS);
   for (int i=0; i<N; i++)
       {
       glVertex3f(R*sin(2*M_PI/N*i)+1.15, 5.7, R*cos(2*M_PI/N*i)+7.6);

       glVertex3f(R*sin(2*M_PI/N*i)+1.15, 6, R*cos(2*M_PI/N*i)+7.6-0.4);

       glVertex3f(R*sin(2*M_PI/N*(i+1))+1.15, 6, R*cos(2*M_PI/N*(i+1))+7.6-0.4);

       glVertex3f(R*sin(2*M_PI/N*(i+1))+1.15, 5.7, R*cos(2*M_PI/N*(i+1))+7.6);
       }
glEnd();

//   
glBegin(GL_QUADS);
   for (int i=0; i<N; i++)
       {
       glVertex3f(R*sin(2*M_PI/N*i)+1.15, 3.3, R*cos(2*M_PI/N*i)+7.6);

       glVertex3f(R*sin(2*M_PI/N*i)+1.15, 5.7, R*cos(2*M_PI/N*i)+7.6);

       glVertex3f(R*sin(2*M_PI/N*(i+1))+1.15, 5.7, R*cos(2*M_PI/N*(i+1))+7.6);

       glVertex3f(R*sin(2*M_PI/N*(i+1))+1.15, 3.3, R*cos(2*M_PI/N*(i+1))+7.6);
       }
glEnd();




}

//-------------------------    ----------------

void Draw_metal()
{

// ---------------------------  ----------------------------------------
glBegin (GL_QUADS);
        //  
        glTexCoord2f(0.0f, 0.0f); glVertex3f(2.6, 4, 2.9);
        glTexCoord2f(1.0f, 0.0f); glVertex3f(2.6, 5, 2.9);
        glTexCoord2f(1.0f, 1.0f); glVertex3f(2.6, 5, 4.1);
        glTexCoord2f(0.0f, 1.0f); glVertex3f(2.6, 4, 4.1);
        //  
        glTexCoord2f(0.0f, 0.0f); glVertex3f(2.3, 4, 2.9);
        glTexCoord2f(1.0f, 0.0f); glVertex3f(2.6, 4, 2.9);
        glTexCoord2f(1.0f, 1.0f); glVertex3f(2.6, 4, 4.1);
        glTexCoord2f(0.0f, 1.0f); glVertex3f(2.3, 4, 4.1);
        //  
        glTexCoord2f(0.0f, 0.0f); glVertex3f(2.3, 5, 2.9);
        glTexCoord2f(1.0f, 0.0f); glVertex3f(2.6, 5, 2.9);
        glTexCoord2f(1.0f, 1.0f); glVertex3f(2.6, 5, 4.1);
        glTexCoord2f(0.0f, 1.0f); glVertex3f(2.3, 5, 4.1);
        //  
        glTexCoord2f(0.0f, 0.0f); glVertex3f(2.6, 4, 4.1);
        glTexCoord2f(1.0f, 0.0f); glVertex3f(2.6, 5, 4.1);
        glTexCoord2f(1.0f, 1.0f); glVertex3f(2.3, 5, 4.1);
        glTexCoord2f(0.0f, 1.0f); glVertex3f(2.3, 4, 4.1);
        //  
        glTexCoord2f(0.0f, 0.0f); glVertex3f(2.6, 4, 2.9);
        glTexCoord2f(1.0f, 0.0f); glVertex3f(2.6, 5, 2.9);
        glTexCoord2f(1.0f, 1.0f); glVertex3f(2.3, 5, 2.9);
        glTexCoord2f(0.0f, 1.0f); glVertex3f(2.3, 4, 2.9);
glEnd();


// -------------------------- , : 4  --------------------------

// 1
//  
glBegin(GL_QUADS);
   for (int i=0; i<N; i++)
       {

       glNormal3f(R*sin(2*M_PI/N*i)+0.5, R*cos(2*M_PI/N*i)+0.5, -0.2);
       glVertex3f(R*sin(2*M_PI/N*i)+0.5, R*cos(2*M_PI/N*i)+0.5, -0.2);

       glNormal3f(R*sin(2*M_PI/N*(i+1))+0.5, R*cos(2*M_PI/N*(i+1))+0.5, -0.2);
       glVertex3f(R*sin(2*M_PI/N*(i+1))+0.5, R*cos(2*M_PI/N*(i+1))+0.5, -0.2);

       glNormal3f(R*sin(2*M_PI/N*(i+1))+0.5, R*cos(2*M_PI/N*(i+1))+0.5, 0);
       glVertex3f(R*sin(2*M_PI/N*(i+1))+0.5, R*cos(2*M_PI/N*(i+1))+0.5, 0);

       glNormal3f(R*sin(2*M_PI/N*i)+0.5, R*cos(2*M_PI/N*i)+0.5, 0);
       glVertex3f(R*sin(2*M_PI/N*i)+0.5, R*cos(2*M_PI/N*i)+0.5, 0);
       }
glEnd();

//   () 
   glBegin(GL_POLYGON);
   for (int i=0; i<N; i++)
                        {   glNormal3f ( 0.5, 0.5, -0.25);
                            glVertex3f( (R*sin(2*M_PI/N*i))+0.5, R*cos(2*M_PI/N*i)+0.5, -0.2);

                         }
  glEnd();

// 2
glBegin(GL_QUADS);
   for (int i=0; i<N; i++)
       {

       glNormal3f(R*sin(2*M_PI/N*i)+1.5, R*cos(2*M_PI/N*i)+0.5, -0.2);
       glVertex3f(R*sin(2*M_PI/N*i)+1.5, R*cos(2*M_PI/N*i)+0.5, -0.2);

       glNormal3f(R*sin(2*M_PI/N*(i+1))+1.5, R*cos(2*M_PI/N*(i+1))+0.5, -0.2);
       glVertex3f(R*sin(2*M_PI/N*(i+1))+1.5, R*cos(2*M_PI/N*(i+1))+0.5, -0.2);

       glNormal3f(R*sin(2*M_PI/N*(i+1))+1.5, R*cos(2*M_PI/N*(i+1))+0.5, 0);
       glVertex3f(R*sin(2*M_PI/N*(i+1))+1.5, R*cos(2*M_PI/N*(i+1))+0.5, 0);

       glNormal3f(R*sin(2*M_PI/N*i)+1.5, R*cos(2*M_PI/N*i)+0.5, 0);
       glVertex3f(R*sin(2*M_PI/N*i)+1.5, R*cos(2*M_PI/N*i)+0.5, 0);
       }
glEnd();

   glBegin(GL_POLYGON);
   for (int i=0; i<N; i++)
                        {   glNormal3f ( 1.5, 0.5, -0.25);
                            glVertex3f( (R*sin(2*M_PI/N*i))+1.5, R*cos(2*M_PI/N*i)+0.5, -0.2);

                         }
  glEnd();

// 3
glBegin(GL_QUADS);
   for (int i=0; i<N; i++)
       {

       glNormal3f(R*sin(2*M_PI/N*i)+1.5, R*cos(2*M_PI/N*i)+8.5, -0.2);
       glVertex3f(R*sin(2*M_PI/N*i)+1.5, R*cos(2*M_PI/N*i)+8.5, -0.2);

       glNormal3f(R*sin(2*M_PI/N*(i+1))+1.5, R*cos(2*M_PI/N*(i+1))+8.5, -0.2);
       glVertex3f(R*sin(2*M_PI/N*(i+1))+1.5, R*cos(2*M_PI/N*(i+1))+8.5, -0.2);

       glNormal3f(R*sin(2*M_PI/N*(i+1))+1.5, R*cos(2*M_PI/N*(i+1))+8.5, 0);
       glVertex3f(R*sin(2*M_PI/N*(i+1))+1.5, R*cos(2*M_PI/N*(i+1))+8.5, 0);

       glNormal3f(R*sin(2*M_PI/N*i)+1.5, R*cos(2*M_PI/N*i)+8.5, 0);
       glVertex3f(R*sin(2*M_PI/N*i)+1.5, R*cos(2*M_PI/N*i)+8.5, 0);
       }
glEnd();

   glBegin(GL_POLYGON);
   for (int i=0; i<N; i++)
                        {   glNormal3f ( 1.5, 8.5, -0.25);
                            glVertex3f( (R*sin(2*M_PI/N*i))+1.5, R*cos(2*M_PI/N*i)+8.5, -0.2);

                         }
  glEnd();

// 4
glBegin(GL_QUADS);
   for (int i=0; i<N; i++)
       {

       glNormal3f(R*sin(2*M_PI/N*i)+0.5, R*cos(2*M_PI/N*i)+8.5, -0.2);
       glVertex3f(R*sin(2*M_PI/N*i)+0.5, R*cos(2*M_PI/N*i)+8.5, -0.2);

       glNormal3f(R*sin(2*M_PI/N*(i+1))+0.5, R*cos(2*M_PI/N*(i+1))+8.5, -0.2);
       glVertex3f(R*sin(2*M_PI/N*(i+1))+0.5, R*cos(2*M_PI/N*(i+1))+8.5, -0.2);

       glNormal3f(R*sin(2*M_PI/N*(i+1))+0.5, R*cos(2*M_PI/N*(i+1))+8.5, 0);
       glVertex3f(R*sin(2*M_PI/N*(i+1))+0.5, R*cos(2*M_PI/N*(i+1))+8.5, 0);

       glNormal3f(R*sin(2*M_PI/N*i)+0.5, R*cos(2*M_PI/N*i)+8.5, 0);
       glVertex3f(R*sin(2*M_PI/N*i)+0.5, R*cos(2*M_PI/N*i)+8.5, 0);
       }
glEnd();

   glBegin(GL_POLYGON);
   for (int i=0; i<N; i++)
                        {   glNormal3f ( 0.5, 8.5, -0.25);
                            glVertex3f( (R*sin(2*M_PI/N*i))+0.5, R*cos(2*M_PI/N*i)+8.5, -0.2);

                         }
  glEnd();

// -----------------------     -------------------
//1
glBegin (GL_QUADS);

        //  
        glTexCoord2f(0.0f, 0.0f); glVertex3f(1.35, 2, 7.1);
        glTexCoord2f(1.0f, 0.0f); glVertex3f(1.45, 3, 7.4);
        glTexCoord2f(1.0f, 1.0f); glVertex3f(0.85, 3, 7.4);
        glTexCoord2f(0.0f, 1.0f); glVertex3f(0.95, 2, 7.1);

        //  
        glTexCoord2f(0.0f, 0.0f); glVertex3f(1.35, 2, 7);
        glTexCoord2f(1.0f, 0.0f); glVertex3f(0.95, 2, 7);
        glTexCoord2f(1.0f, 1.0f); glVertex3f(0.95, 2, 7.1);
        glTexCoord2f(0.0f, 1.0f); glVertex3f(1.35, 2, 7.1);

        //  
        glTexCoord2f(0.0f, 0.0f); glVertex3f(1.45, 3, 7);
        glTexCoord2f(1.0f, 0.0f); glVertex3f(0.85, 3, 7);
        glTexCoord2f(1.0f, 1.0f); glVertex3f(0.85, 3, 7.4);
        glTexCoord2f(0.0f, 1.0f); glVertex3f(1.45, 3, 7.4);

        //  
        glTexCoord2f(0.0f, 0.0f); glVertex3f(1.35, 2, 7);
        glTexCoord2f(1.0f, 0.0f); glVertex3f(1.45, 3, 7);
        glTexCoord2f(1.0f, 1.0f); glVertex3f(1.45, 3, 7.4);
        glTexCoord2f(0.0f, 1.0f); glVertex3f(1.35, 2, 7.1);

        //  
        glTexCoord2f(0.0f, 0.0f); glVertex3f(0.95, 2, 7);
        glTexCoord2f(1.0f, 0.0f); glVertex3f(0.85, 3, 7);
        glTexCoord2f(1.0f, 1.0f); glVertex3f(0.85, 3, 7.4);
        glTexCoord2f(0.0f, 1.0f); glVertex3f(0.95, 2, 7.1);
glEnd();

//2
glBegin (GL_QUADS);

        //  
        glTexCoord2f(0.0f, 0.0f); glVertex3f(1.45, 6, 7.4);
        glTexCoord2f(1.0f, 0.0f); glVertex3f(1.35, 7, 7.1);
        glTexCoord2f(1.0f, 1.0f); glVertex3f(0.95, 7, 7.1);
        glTexCoord2f(0.0f, 1.0f); glVertex3f(0.85, 6, 7.4);

        //  
        glTexCoord2f(0.0f, 0.0f); glVertex3f(1.45, 6, 7);
        glTexCoord2f(1.0f, 0.0f); glVertex3f(0.85, 6, 7);
        glTexCoord2f(1.0f, 1.0f); glVertex3f(0.85, 6, 7.4);
        glTexCoord2f(0.0f, 1.0f); glVertex3f(1.45, 6, 7.4);

        //  
        glTexCoord2f(0.0f, 0.0f); glVertex3f(1.35, 7, 7);
        glTexCoord2f(1.0f, 0.0f); glVertex3f(0.95, 7, 7);
        glTexCoord2f(1.0f, 1.0f); glVertex3f(0.95, 7, 7.1);
        glTexCoord2f(0.0f, 1.0f); glVertex3f(1.35, 7, 7.1);

        //  
        glTexCoord2f(0.0f, 0.0f); glVertex3f(1.45, 6, 7);
        glTexCoord2f(1.0f, 0.0f); glVertex3f(1.35, 7, 7);
        glTexCoord2f(1.0f, 1.0f); glVertex3f(1.35, 7, 7.1);
        glTexCoord2f(0.0f, 1.0f); glVertex3f(1.45, 6, 7.4);

        //  
        glTexCoord2f(0.0f, 0.0f); glVertex3f(0.85, 6, 7);
        glTexCoord2f(1.0f, 0.0f); glVertex3f(0.95, 7, 7);
        glTexCoord2f(1.0f, 1.0f); glVertex3f(0.95, 7, 7.1);
        glTexCoord2f(0.0f, 1.0f); glVertex3f(0.85, 6, 7.4);
glEnd();


}

//---------------------------------------------------------------------------
// 
void __fastcall TFormMain::DrawObjects()
{

  glPolygonMode(GL_FRONT_AND_BACK,GL_FILL);

  //   
  glBindTexture(GL_TEXTURE_2D,texture1);
  //     
  Draw_skin();

  //  
  glBindTexture(GL_TEXTURE_2D,texture2);
  //       
  Draw_metal();

}

//---------------------------------------------------------------------------

void __fastcall TFormMain::FormPaint(TObject *Sender)
{
    glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
    glFlush();

    DrawObjects();
    
}
//---------------------------------------------------------------------------
void __fastcall TFormMain::FormDestroy(TObject *Sender)
{
    wglMakeCurrent(NULL, NULL);
    wglDeleteContext(hrc);
}
//---------------------------------------------------------------------------
void __fastcall TFormMain::FormKeyDown(TObject *Sender, WORD &Key,
      TShiftState Shift)
{
    if(Key == VK_UP)
       { glRotatef(-5, 1.0, 0.0, 0.0);  }
    if(Key == VK_DOWN)
       { glRotatef(5, 1.0, 0.0, 0.0);}
    if(Key == VK_LEFT)
       { glRotatef(-5, 0.0, 1.0, 0.0); }
    if(Key == VK_RIGHT)
       { glRotatef(5, 0.0, 1.0, 0.0); }
    if(Key == VK_ADD)
       { glScalef(1.05,1.05,1.05);
        }
    if(Key == VK_SUBTRACT)
       { glScalef(0.95,0.95,0.95);
        }

}
//---------------------------------------------------------------------------
void __fastcall TFormMain::SetupTextures()
{

//     
 bitmap = new Graphics::TBitmap;
    bitmap->LoadFromFile("pic1.bmp");
    GLubyte bits[64][64][4];
    for(int i = 0; i < 64; i++)
    {
    	for(int j = 0; j < 64; j++)
        {
            bits[i][j][0]= (GLbyte)GetRValue(bitmap->Canvas->Pixels[i][j]);
            bits[i][j][1]= (GLbyte)GetGValue(bitmap->Canvas->Pixels[i][j]);
            bits[i][j][2]= (GLbyte)GetBValue(bitmap->Canvas->Pixels[i][j]);
            bits[i][j][3]= (GLbyte)255;
        }
    }
    glPixelStorei(GL_UNPACK_ALIGNMENT, 4);
    glGenTextures(1, &texture1);
    glBindTexture(GL_TEXTURE_2D, texture1);
    glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_S, GL_CLAMP);
    glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_T, GL_CLAMP);
    glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_NEAREST);
    glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_NEAREST);
    glTexImage2D(GL_TEXTURE_2D, 0, GL_RGBA, 64, 64, 0, GL_RGBA, GL_UNSIGNED_BYTE, bits);
    glEnable(GL_TEXTURE_2D);
    glTexEnvf(GL_TEXTURE_ENV, GL_TEXTURE_ENV_MODE, GL_MODULATE);
     bitmap->LoadFromFile("pic2.bmp");
 //   GLubyte bits[64][64][4];
    for(int i = 0; i < 64; i++)
    {
    	for(int j = 0; j < 64; j++)
        {
            bits[i][j][0]= (GLbyte)GetRValue(bitmap->Canvas->Pixels[i][j]);
            bits[i][j][1]= (GLbyte)GetGValue(bitmap->Canvas->Pixels[i][j]);
            bits[i][j][2]= (GLbyte)GetBValue(bitmap->Canvas->Pixels[i][j]);
            bits[i][j][3]= (GLbyte)255;
        }
    }
    glPixelStorei(GL_UNPACK_ALIGNMENT, 4);
    glGenTextures(1, &texture2);
    glBindTexture(GL_TEXTURE_2D, texture2);
    glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_S, GL_CLAMP);
    glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_T, GL_CLAMP);
    glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_NEAREST);
    glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_NEAREST);
    glTexImage2D(GL_TEXTURE_2D, 0, GL_RGBA, 64, 64, 0, GL_RGBA, GL_UNSIGNED_BYTE, bits);
    glEnable(GL_TEXTURE_2D);
    glTexEnvf(GL_TEXTURE_ENV, GL_TEXTURE_ENV_MODE, GL_MODULATE);

}

//---------------------------------------------------------------------------
void __fastcall TFormMain::SetupLighting()
{
    GLfloat MaterialAmbient[] = {1.0, 1.0, 1.0, 1.0};
    GLfloat MaterialDiffuse[] = {1.0, 1.0, 1.0, 1.0};
    GLfloat MaterialSpecular[] = {1.0, 1.0, 1.0, 1.0};
    GLfloat MaterialShininess[] = {100.0};
    GLfloat AmbientLightPosition[] = {0.5, 1.0, 1.0, 0.0};
    GLfloat LightAmbient[] = {0.5, 0.5, 0.5, 1.0};

    glMaterialfv(GL_FRONT, GL_AMBIENT, MaterialAmbient);
    glMaterialfv(GL_FRONT, GL_DIFFUSE, MaterialDiffuse);
    glMaterialfv(GL_FRONT, GL_SPECULAR, MaterialSpecular);
    glMaterialfv(GL_FRONT, GL_SHININESS, MaterialShininess);
    glLightfv(GL_LIGHT0, GL_POSITION, AmbientLightPosition);
    glLightModelfv(GL_LIGHT_MODEL_AMBIENT, LightAmbient);

    glEnable(GL_LIGHTING);
    glEnable(GL_LIGHT0);
    glEnable(GL_COLOR_MATERIAL);
    glColorMaterial(GL_FRONT, GL_AMBIENT_AND_DIFFUSE);
    glShadeModel(GL_SMOOTH);
}

//---------------------------------------------------------------------------
void __fastcall TFormMain::Timer1Timer(TObject *Sender)
{
   RenderGLScene();   // 
    SwapBuffers(hdc);  //  

}
//---------------------------------------------------------------------------

